'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5205] on 10 May 2003 at 4:05:30 pm'!
"Change Set:		BugFixArchive-UI-bkv
Date:			10 May 2003
Author:			Brent Vukmer

This viewer is meant to be a handy tool for individual Squeakers to comment on proposed fixes and enhancements for Squeak.  The BugFixArchiveViewer automates a good bit of the process of browsing to the Bug Fixes Archive, downloading a fix/enhancement changeset, evaluating the changeset, and posting a comment to the Squeak development email list."!

SMLoader subclass: #BugFixArchiveViewer
	instanceVariableNames: 'bugFixArchive archivePostsList archivePostsListIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFixArchive-UI'!

!BugFixArchiveViewer commentStamp: 'bkv 5/10/2003 15:52' prior: 0!
This viewer is meant to be a handy tool for individual Squeakers to comment on proposed fixes and enhancements for Squeak.  The BugFixArchiveViewer automates a good bit of the process of browsing to the Bug Fixes Archive, downloading a fix/enhancement changeset, evaluating the changeset, and posting a comment to the Squeak development email list. 

An instance of BugFixArchiveViewer allows you to view a copy of the Bug Fixes Archive ( currently reachable over the Web by going to http://swiki.gsug.org/sqfixes ). You can open a BugFixArchiveViewer by going to the world menu, clicking on 'open', and then clicking on 'Bug Fix Archive Viewer', or you can execute the following code as a do-it:

  BugFixArchiveViewer open.

This opens a viewer on the *default* local copy of the archive.  (A BugFixArchiveViewer uses an instance of the BugFixArchive class as its model).  If you want to investigate the default local copy used by the viewer, do:

  BugFixArchive default inspect.

If you want to open a viewer on a *custom* copy of the archive, use:
  
  BugFixArchiveViewer openOn: aBugFixArchiveInstance.

See the comments on the BugFixArchive class for further notes on how the local copy is initialized.

The viewer offers the following services:
  1.) The left-hand panel shows a filtered list of archive post titles.
  2.) The mouse menu on the left-hand panel has several options for viewing archive changesets.
  3.) The mouse menu also has several options for filtering the list.
        * if nothing is selected, everything is shown
        * if date-filters are selected, it filters out posts that don't match the date-filters
        * see BugFixArchiveViewer>>archivePostsList for more details
  4.) The right-hand panel shows the details for the currently-selected archive post.


Please note: the first time that you open a viewer, it will initialize the default local copy of the archive.  This may take a while!!  

System Recomendations:

Get the most current VM for your platform.  I saw some weird socket errors when I was running the 3.2.2 Windows VM.  They seem to have gone away with the 3.4.4 Windows VM.

Dependencies:

SMLoader
MailSender
BugFixArchive
Scamper ( dependency for the model class, BugFixArchive )
HTTPSocket ( dependency for the model class, BugFixArchive )
SwikiProjectPageOrganizer ( dependency for the model class, BugFixArchive )

Developer Notes:

TBD List: 

1) Date filtering stuff should use *real Date objects*, not String match:
2) The loadUpdates method should probably run in background process
3) Add filter by title (get input from popup, use regexp)
4) Add filter by years (get input from popups)
5) Get rid of hard-coded filter-by-year methods




!


!BugFixArchiveViewer methodsFor: 'accessing' stamp: 'bkv 5/9/2003 12:03'!
archivePostsListIndex

  archivePostsListIndex isNil ifTrue: [ self archivePostsListIndex: 1 ].

  ^archivePostsListIndex! !

!BugFixArchiveViewer methodsFor: 'accessing' stamp: 'bkv 5/9/2003 23:06'!
archivePostsListIndex: anObject

	archivePostsListIndex _ anObject.
	self changed: #archivePostsListIndex.	"update my selection"
	self contentsChanged! !

!BugFixArchiveViewer methodsFor: 'accessing' stamp: 'bkv 5/10/2003 13:35'!
filter: anObject 
	"update my selection"

	| oldSelection index |
	oldSelection := self selectedArchivePost.
	filter := anObject.
	self archivePostsListIndex: ((index _ self archivePostsList indexOf: oldSelection) 
				ifNil: [0]
				ifNotNil: [index]).
	self noteChanged! !

!BugFixArchiveViewer methodsFor: 'accessing' stamp: 'bkv 5/9/2003 22:12'!
fullFileNameForDownload
  downloadDirectory isNil ifTrue: [ self error: 'No download directory is set!!' ].
  self selectedArchivePost isNil ifTrue: [ ^nil ].
  ^(downloadDirectory fileNamed: self selectedArchivePost relativeFileNameForChangeset) asString! !

!BugFixArchiveViewer methodsFor: 'accessing' stamp: 'bkv 5/9/2003 12:04'!
noteChanged
	self changed: #archivePostNameList.
	self changed: #archivePostsListIndex.	"update my selection"
	self contentsChanged.! !

!BugFixArchiveViewer methodsFor: 'gui building' stamp: 'bkv 5/9/2003 21:06'!
buildMorphicPackagesList
	| list |
	(list _ PluggableListMorph new) 
			on: self 
			list: #archivePostNameList
			selected: #archivePostsListIndex 
			changeSelected: #archivePostsListIndex:
			menu: #archivePostsMenu: 
			keystroke: #archivePostsListKey:from:.
	^list! !

!BugFixArchiveViewer methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:41'!
defaultUpdatablePaneSelectors

  ^ #(#archivePostNameList #selectedArchivePostsList).! !

!BugFixArchiveViewer methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:42'!
paneColor
	^ Color green darker duller! !

!BugFixArchiveViewer methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:40'!
windowLabel

  ^'Bug Fix Archive Viewer'! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/10/2003 13:57'!
archivePostNameList
	^self archivePostsList collect: [:e | e title, '  ',  '(Archive #', e archiveNumber asString, ')' ]! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/10/2003 14:09'!
archivePostsList
  "Returns a list archive posts that meet the current filtering requirements."

  ^(self archivePosts) 
		select: [:e | (self datesFilterBlock value: e) 
					  and: [ self generalFilterBlock value: e ]].! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/9/2003 20:57'!
archivePostsMenu: aMenu 
	"Answer the packages-list menu"

	| choices |
	choices := OrderedCollection new.
	choices addAll: self generalOptions.
	aMenu addList: choices.
	self addFiltersToMenu: aMenu.
	^aMenu! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/10/2003 14:05'!
datesFilterBlock
  "Returns a list archive posts that meet the current date filtering requirements.  If no date filters are set, return all posts."

  ^[:post | | dateFilters |
		  dateFilters _ self dateFilters.
            (dateFilters isNil or: [ dateFilters isEmpty ]) 
               or: [ dateFilters anySatisfy: [:currFilter | (self perform: currFilter) value: post ] ]] 
! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/10/2003 14:07'!
generalFilterBlock
  "Returns a list archive posts that meet the current general (i.e., non-date) filtering requirements.  If no general filters are set, return everything."

  ^[:post | | filters |
		   filters _ self generalFilters.
            (filters isNil or: [ filters isEmpty ]) 
               or: [ filters anySatisfy: [:currFilter | (self perform: currFilter) value: post ] ]] 
! !

!BugFixArchiveViewer methodsFor: 'lists' stamp: 'bkv 5/10/2003 13:43'!
generalOptions
	^#( #('download changeset' downloadChangeSet 'Download the changeset file for this archive post to the current download directory.' )
		#('view changeset text' viewChangeSetText 'View the changeset file for this archive post, in a text window.' )
		#('browse changelist' browseChangeList 'Browse the list of changeset elements.' )
		#('install changeset' installChangeSet 'Install the changeset file for this archive post, into a new ChangeSet.' )
		#('post comment' postCommentOnFixOrEnhancement 'Post a comment on the fix/enhancement to the Bug Fixes Archive.' )
		#- 
          #('refresh bug fix archive' loadUpdates 'Refresh the locally-cached BugFixArchive from the server.')
		#('set download directory' setDownloadDirectory 'Set the directory where downloaded changesets will be placed. (By default, this will the Squeak default directory.') 
		#- )! !

!BugFixArchiveViewer methodsFor: 'model' stamp: 'bkv 5/9/2003 12:11'!
archivePosts
	"Archive posts sorted by archive number"
	^self model archivePosts! !

!BugFixArchiveViewer methodsFor: 'model' stamp: 'bkv 5/9/2003 13:31'!
contents
  | archivePost |

  archivePost _ self selectedArchivePost.
  ^archivePost ifNil: [ '<No archive post selected>' ] ifNotNil: [ archivePost fullDescription ]! !

!BugFixArchiveViewer methodsFor: 'model' stamp: 'bkv 5/10/2003 14:27'!
loadUpdates
	Cursor write showWhile: [ self model loadUpdates ].
	self noteChanged ! !

!BugFixArchiveViewer methodsFor: 'model' stamp: 'bkv 5/9/2003 12:56'!
selectedArchivePost

	^(self archivePostsListIndex = 0) | (self archivePostsList size < self archivePostsListIndex) ifFalse: [self archivePostsList at: self archivePostsListIndex] ifTrue: [nil]! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 13:15'!
browseChangeList
  "This external service relies on downloading the changeset first."
  | fileStream fileName selector |

  fileStream _ self downloadChangeSetIfNecessary.
  fileName _ fileStream name.
  selector _ #browseChangesFile:.
  (fileName endsWith: '.cs.gz')
    ifTrue: [ selector _ #browseCompressedChangesFile: ].

  self performExternalService: selector withArguments: { fileName } viaServiceProvider: (Smalltalk at: #ChangeList ).! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 14:30'!
downloadChangeSet
"Most external services rely on downloading the changeset first.  However, those services are not required/expected to check that the changeset was downloaded completely.  This method may need to be called as a 'refresh' by the user.

NOTE: I'm convinced that this *should* be an external service -- I just don't know what to call.  So, for now, I'll use a method on ArchivePost."

  | file | 
  Cursor write showWhile: [ file _ self selectedArchivePost saveChangeSetToDirectory: downloadDirectory ].

  ^file
 ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 12:59'!
downloadChangeSetIfNecessary
"Most external services rely on downloading the changeset first.  However, those services are not required/expected to check that the changeset was downloaded completely.  The #downloadChangeSet method may need to be called as a 'refresh' by the user."

     | relativeFileName |

     relativeFileName _ self selectedArchivePost relativeFileNameForChangeset.

     ( downloadDirectory fileExists: relativeFileName )
         ifTrue: [ ^downloadDirectory fileNamed: relativeFileName ]
         ifFalse: [ ^self downloadChangeSet ]

 ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/9/2003 14:19'!
downloadFileName

  ^downloadDirectory fullNameFor: self selectedArchivePost relativeFileNameForChangeset.
     
 ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 13:27'!
installChangeSet
  "This external service relies on downloading the changeset first."
   | fileName |

   fileName _ self downloadChangeSetIfNecessary name.
   self performExternalService: #fileIntoNewChangeSet: withArguments: { fileName } viaServiceProvider: (Smalltalk at: #GZipReadStream).

  ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/9/2003 13:56'!
performExternalService: aSymbol withArguments: anArrayOfArgs viaServiceProvider: anObject

    ( anObject isNil )
        ifTrue: [ self error: 'Service provider ', anObject asString, ' does not appear to be loaded into this system.' ]
	   ifFalse: [ anObject perform: aSymbol withArguments: anArrayOfArgs ]
  ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 15:07'!
postCommentOnFixOrEnhancement
   "Right now we post comments as emails to the squeak-dev list, where they are harvested by the Bug Fixes Archive."

   self downloadChangeSetIfNecessary.
   self postCommentViaEmail.
  ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 14:32'!
postCommentViaEmail

	Cursor write showWhile: [  self performExternalService: #postCommentViaEmail
								    withArguments: {} 
								    viaServiceProvider: self selectedArchivePost ].

  

  ! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 13:24'!
viewChangeSetText
  "Code stolen from FileStream >> viewGZipContents"

   | file stringContents |

   file _ self downloadChangeSetIfNecessary.
   (file name endsWith: '.cs.gz')
	  ifTrue: [ ^self viewDecompressedChangeSetText ].

    Cursor wait showWhile: [ stringContents _ file open contentsOfEntireFile asString withSqueakLineEndings ].

	Workspace new
		contents: stringContents;
		openLabel: 'Contents of: ', file name! !

!BugFixArchiveViewer methodsFor: 'external services' stamp: 'bkv 5/10/2003 13:23'!
viewDecompressedChangeSetText
  "This external service relies on downloading the changeset first."
   | fileName |

   fileName _ self downloadChangeSetIfNecessary name.
   self performExternalService: #viewContents: withArguments: { fileName } viaServiceProvider: (Smalltalk at: #GZipReadStream).! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/10/2003 13:40'!
dateFilters

	^self filter select: [ :any | self isDateFilter: any ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/10/2003 13:36'!
defaultFilters
  
  ^{ #filterShowFixes.
     #filterShowEnhancements.
     #filterShowFrom2003.
}! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/9/2003 20:51'!
filterShowEnhancements

 ^[ :archivePost | archivePost isEnhancement ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/9/2003 20:51'!
filterShowFixes

 ^[ :archivePost | archivePost isFix ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/9/2003 21:14'!
filterShowFrom2001
 "This method should be paramerized.  I am a BAD MAN."

 ^[ :archivePost | '*2001*' match: archivePost dateSent asString ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/9/2003 21:15'!
filterShowFrom2002
 "This method should be paramerized.  I am a BAD MAN."

 ^[ :archivePost | '*2002*' match: archivePost dateSent asString ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/9/2003 21:15'!
filterShowFrom2003
 "This method should be paramerized.  I am a BAD MAN."

 ^[ :archivePost | '*2003*' match: archivePost dateSent asString ]! !

!BugFixArchiveViewer methodsFor: 'filters' stamp: 'bkv 5/10/2003 13:49'!
generalFilters

	^self filter reject: [ :any | self isDateFilter: any ]! !

!BugFixArchiveViewer methodsFor: 'filter utilities' stamp: 'bkv 5/9/2003 11:47'!
filterSpecs
     | specs |
	
	specs _ OrderedCollection withAll: self filterSpecsForArchivePostTypes.
     specs addAll: self filterSpecsForTimeLimits.

    ^specs asArray! !

!BugFixArchiveViewer methodsFor: 'filter utilities' stamp: 'bkv 5/9/2003 11:47'!
filterSpecsForArchivePostTypes
    "This should probably be parameterized."
	^#(	#('show me fixes ' #filterShowFixes 'show me [FIX] posts to the Bug Fix Archive') 
		#('show me enhancements' #filterShowEnhancements 'show me [ENH] posts to the Bug Fix Archive') )! !

!BugFixArchiveViewer methodsFor: 'filter utilities' stamp: 'bkv 5/9/2003 21:16'!
filterSpecsForTimeLimits
     "This should be parameterized based on year  ( and month? ) and auto-generated based on data from the bugFixArchive model."

	^#(	#('show me stuff from 2003' #filterShowFrom2003 'show me posts to the Bug Fix Archive during 2003') 
		#('show me stuff from 2002' #filterShowFrom2002 'show me posts to the Bug Fix Archive during 2002')
          #('show me stuff from 2001' #filterShowFrom2001 'show me posts to the Bug Fix Archive during 2001') )! !

!BugFixArchiveViewer methodsFor: 'filter utilities' stamp: 'bkv 5/10/2003 13:38'!
isDateFilter: aSymbol

  ^'filterShowFrom*' match: aSymbol asString! !


!BugFixArchiveViewer class methodsFor: 'menu registration' stamp: 'bkv 5/9/2003 19:57'!
initialize
  "BugFixArchiveViewer initialize."

  super initialize.! !

!BugFixArchiveViewer class methodsFor: 'menu registration' stamp: 'bkv 5/8/2003 17:33'!
menuRegistrationKey

^'Bug Fix Archive Viewer'! !

!BugFixArchiveViewer class methodsFor: 'instance creation' stamp: 'bkv 5/8/2003 18:07'!
new
	"Create a viewer on the default BugFixArchive object ( which is created using cached values for the older bug fix posts )."

	^self newOn: BugFixArchive default! !

!BugFixArchiveViewer class methodsFor: 'instance creation' stamp: 'bkv 5/8/2003 18:12'!
open
	"Create and open a BugFixArchive Viewer on the default instance of the BugFixArchive, that uses a cached set of URLs to start."
	"self open"

	self openOn: BugFixArchive default! !

BugFixArchiveViewer initialize!
BugFixArchiveViewer removeSelector: #mailServiceProvider!
BugFixArchiveViewer removeSelector: #postCommentViaEmailTo:!
BugFixArchiveViewer removeSelector: #sendEmailTo:!
BugFixArchiveViewer removeSelector: #viewDecompressedChangeSet!

!BugFixArchiveViewer reorganize!
('accessing' archivePostsListIndex archivePostsListIndex: filter: fullFileNameForDownload noteChanged)
('gui building' buildMorphicPackagesList defaultUpdatablePaneSelectors paneColor windowLabel)
('lists' archivePostNameList archivePostsList archivePostsMenu: datesFilterBlock generalFilterBlock generalOptions)
('model' archivePosts contents loadUpdates selectedArchivePost)
('external services' browseChangeList downloadChangeSet downloadChangeSetIfNecessary downloadFileName installChangeSet performExternalService:withArguments:viaServiceProvider: postCommentOnFixOrEnhancement postCommentViaEmail viewChangeSetText viewDecompressedChangeSetText)
('filters' dateFilters defaultFilters filterShowEnhancements filterShowFixes filterShowFrom2001 filterShowFrom2002 filterShowFrom2003 generalFilters)
('filter utilities' filterSpecs filterSpecsForArchivePostTypes filterSpecsForTimeLimits isDateFilter:)
!

